<?php
/*
	Zen cart module for Point payment service.
*/


    class point {
    var $code, $title, $description, $enabled, $shop_private_key_file,  $pay_page_public_key_file;

// class constructor
    function point() { 
      global $order;
      
      $this->code = 'point';
      $this->title = MODULE_PAYMENT_POINT_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_POINT_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_POINT_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_POINT_STATUS == 'True') ? true : false);
   
      $this->merchant_agreement_code = MODULE_PAYMENT_POINT_MERCHANT_ID;

      if ((int)MODULE_PAYMENT_POINT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_POINT_ORDER_STATUS_ID;
      }
 
         if (is_object($order)) { $this->update_status(); }

         $this->form_action_url = '';

     $this->shop_private_key_file = MODULE_PAYMENT_POINT_PRIVATE_KEY;
     $this->pay_page_public_key_file = MODULE_PAYMENT_POINT_PUBLIC_KEY;
   }

// class methods
    function update_status() {
       global $order, $db;
  
      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_POINT_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_POINT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
         $check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }



    function javascript_validation() {
      return false;
    }

    function selection() {
          return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      $this->form_action_url = $this->_get_payment_url();
      if(!$this->form_action_url) {
       zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=point', 'SSL', true, false)."&error=no_gateway_available");
       }
      return false;
    }

    function confirmation() {
      return false;
    }

  function process_button() {
    $fields = $this->_build_fields();
      
    $process_button_string = '<script type="text/javascript"> var els = document.getElementsByName("securityToken"); els[0].parentNode.removeChild(els[0]);</script>';
      
    foreach($fields as $key => $value ) {
     $process_button_string .= zen_draw_hidden_field($key, $value) ."\n";
    }
    return $process_button_string;
  }


 // Validates the response. 
   function before_process() {
    global $order;
    unset($_POST["s-t-1-40_shop-receipt__phase"]);
    $signedformdata = $_POST;
    $renderdata = $_POST;
    unset($signedformdata["s-t-256-256_signature-one"]);
    unset($signedformdata["s-t-256-256_signature-two"]);  
   
    $signature_valid = @$this->_verifysignature($this->_formatparameters($signedformdata), $_POST["s-t-256-256_signature-one"]);


   $order_id = (int) $_POST['s-f-1-36_order-number'];

   $transaction_number = preg_replace("/[[:^digit:]]/", '', $_POST['l-f-1-20_transaction-number']);

   $sum_in_db = $this->_update_payment_db($order_id, $transaction_number);

   if($signature_valid and $sum_in_db === false) {
     // double entry, order is being processed already
     $_SESSION['cart']->reset(); // empty cart
     sleep(3); // give order processing time to complete
     zen_redirect(zen_href_link(FILENAME_ACCOUNT_HISTORY,'','SSL'));
     die();
   }

    if($signature_valid == false or
       !isset($_POST['l-f-1-20_transaction-number']) or
       $_POST['l-f-1-20_order-gross-amount'] != $sum_in_db or
       abs(($_POST['l-f-1-20_order-gross-amount'] - ($this->_convert_to_euro($order->info['total'])*100)) > 0.01)
      ) {   
       zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=point', 'SSL', true, false)."&error=invalid_signature");
      die();
    }
  
    return false;
  }

  function after_process() {
    return false;
  }

  function get_error() {
    $error_text='';
    switch ($_GET['error']) {
     case 'invalid_signature':
       $error_text =  MODULE_PAYMENT_POINT_TEXT_ERROR_INVALID_SIGNATURE;
       break;
     case 'no_gateway_available':
        $error_text = MODULE_PAYMENT_POINT_TEXT_ERROR_NO_PAYMENT_GATEWAY_AVAILABLE;
       break;
     default: 
        $error_text = MODULE_PAYMENT_POINT_TEXT_ERROR_NO_PAYMENT_GATEWAY_AVAILABLE;
        break;
    }
     return array('title' => MODULE_PAYMENT_POINT_ERROR_TITLE, 'error' => $error_text);
  }

    function check() {
      global $db;
      if (!isset($this->_check)) {
       $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_POINT_STATUS'");
      $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Point Payment Status', 'MODULE_PAYMENT_POINT_STATUS', 'True', 'Is the payment method enabled?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_POINT_ZONE', '0', 'If zone is set, this payment method is available only for the selected zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order.', 'MODULE_PAYMENT_POINT_SORT_ORDER', '0', 'Display order of the payment module. Lower value comes first.', '6', '3', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Payment status', 'MODULE_PAYMENT_POINT_ORDER_STATUS_ID', '0', 'What is the status of the payment paid with using this payment module.', '6', '4', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_POINT_MERCHANT_ID', '', 'Merchant id received from Point.', '6', '5', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shop private key file', 'MODULE_PAYMENT_POINT_PRIVATE_KEY', '', 'Path and name to the private key file', '6', '6', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Point public key', 'MODULE_PAYMENT_POINT_PUBLIC_KEY', '', 'Path and name to the payment system public key file', '6', '6', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Currrency', 'MODULE_PAYMENT_POINT_CURRENCY', 'EUR', 'Payment Currency', '6', '8', 'zen_cfg_select_option(array(\'EUR\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Availability check', 'MODULE_PAYMENT_POINT_AVAILABILITY_CHECK', 'True', 'Make availability check for the payment system.', '6', '9', 'zen_cfg_select_option(array(\'True\',\'False\'), ', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment URL1', 'MODULE_PAYMENT_POINT_ULR1', 'https://epayment-1.point.fi/pw', 'Endpoint URL for the payment system', '6', '6', now())");  


      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment URL2', 'MODULE_PAYMENT_POINT_ULR2', 'https://epayment-2.point.fi/pw', 'Endpoint URL for the payment system', '6', '6', now())");  


      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment URL3', 'MODULE_PAYMENT_POINT_ULR3', 'https://epayment-3.point.fi/pw', 'Endpoint URL for the payment system', '6', '6', now())");  

   // database tables
   // total sum format is same as in Point payment e.g. 150 means 1 euro 50 cents
      $db->Execute(
       "CREATE TABLE IF NOT EXISTS point_payments  (
        payment_id int(11) NOT NULL auto_increment,
        transaction_number varchar(20) default NULL,
        customer_id int(11) default 0,
        total_sum int(11) default 0, 
        time_created timestamp DEFAULT NOW(),
        time_processed timestamp DEFAULT '0000-00-00 00:00:00',
        UNIQUE KEY (payment_id)
       ) ENGINE=MyISAM;");

     }

  function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      $db->Execute("DROP TABLE point_payments");
   }

 function keys() {
      $keys = array('MODULE_PAYMENT_POINT_STATUS',  'MODULE_PAYMENT_POINT_ZONE','MODULE_PAYMENT_POINT_SORT_ORDER',
'MODULE_PAYMENT_POINT_ORDER_STATUS_ID','MODULE_PAYMENT_POINT_MERCHANT_ID','MODULE_PAYMENT_POINT_CURRENCY',
'MODULE_PAYMENT_POINT_AVAILABILITY_CHECK','MODULE_PAYMENT_POINT_PRIVATE_KEY','MODULE_PAYMENT_POINT_PUBLIC_KEY',
'MODULE_PAYMENT_POINT_ULR1','MODULE_PAYMENT_POINT_ULR2','MODULE_PAYMENT_POINT_ULR3'
);
      return $keys;
    }

  function _build_fields() {
    global  $order;
    $fields = array();

    $order_gross_amount = $this->_convert_to_euro($order->info['total'])*100;
    $order_net_amount = $this->_convert_to_euro($order->info['subtotal'])*100;
    $order_vat_amount = $this->_convert_to_euro($order->info['tax'])*100;
    if(empty($order_vat_amount)) { $order_vat_amount = "0"; }
    $currency_code = '978'; // EURO  
    $order_timestamp = gmdate("Y-m-d H:i:s");

    $order_number = $this->_store_db($order_gross_amount);
    
    $fields['locale-f-2-5_payment-locale'] = 'fi_FI';
    $fields['t-f-14-19_payment-timestamp'] = $order_timestamp;
    $fields['s-f-1-36_merchant-agreement-code'] = $this->merchant_agreement_code;
    $fields['s-f-1-36_order-number'] = $order_number;
    $fields['t-f-14-19_order-timestamp'] = $order_timestamp;
    $fields['i-f-1-3_order-currency-code'] = $currency_code;
    $fields['l-f-1-20_order-gross-amount'] = $order_gross_amount;
    $fields['l-f-1-20_order-net-amount'] = $order_net_amount;
    $fields['l-f-1-20_order-vat-amount'] = $order_vat_amount;
    $fields['s-f-1-30_buyer-first-name'] = $this->_sanitise($order->customer['firstname']);
    $fields['s-f-1-30_buyer-last-name'] = $this->_sanitise($order->customer['lastname']);
    if(!empty($order->customer['telephone'])) {
      $fields['s-t-1-30_buyer-phone-number'] = $this->_sanitise($order->customer['telephone']); }
    $fields['s-f-1-100_buyer-email-address'] = $this->_sanitise($order->customer['email_address']);

   // address lines handling
   // if street address . suburb is more than 30 chars, split it brutally to 2 lines
   // if state, add it to the next (2nd or 3rd) line
    $address_lines = str_split($order->delivery['street_address'] . $order->delivery['suburb'], 
                               30);
    $fields['s-t-1-30_delivery-address-line-one'] = $this->_sanitise($address_lines[0]);
    if(isset($address_lines[1])) {
      $fields['s-t-1-30_delivery-address-line-two'] = $this->_sanitise($address_lines[1]);
      if(!empty($order->delivery['state'])) {
        $fields['s-t-1-30_delivery-address-line-three'] = $this->_sanitise($order->delivery['state']);
      }
     } else {
      if(!empty($order->delivery['state'])) {
        $fields['s-t-1-30_delivery-address-line-two'] = $this->_sanitise($order->delivery['state']);
     }
   }
   
   if(!empty($order->delivery['city'])) {
     $fields['s-t-1-30_delivery-address-city'] = $this->_sanitise($order->delivery['city']);
   }
   
   if(!empty($order->delivery['postcode'])) {
     $fields['s-t-1-30_delivery-address-postal-code'] = $this->_sanitise($order->delivery['postcode']);
   }
   if(!empty($order->delivery['country']['iso_code_3'])) {
     $fields['i-t-1-3_delivery-address-country-code'] = $this->_map_iso3_countrycode_to_numeric($order->delivery['country']['iso_code_3']);
   }
   if(ENABLE_SSL == true) {
    $success_url = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . 'pointpayment.php'; 
   } else {
    $success_url = HTTP_SERVER . DIR_WS_HTTP_CATALOG . 'pointpayment.php';
   }
 
   $fields['s-f-5-128_success-url'] =  $success_url;
   $fields['s-f-5-128_rejected-url'] = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
   $fields['s-f-5-128_cancel-url'] = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
   $fields['s-f-5-128_expired-url'] = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
   $fields['s-f-5-128_error-url'] = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'); 
   $fields['s-f-1-30_software'] = "Zen cart";
   $fields['s-f-1-10_software-version'] = $this->_sanitise(PROJECT_VERSION_MAJOR . '.' . PROJECT_VERSION_MINOR . (PROJECT_VERSION_PATCH1 != '' ? 'p' . PROJECT_VERSION_PATCH1 : ''), 10, true);
   
   if(!empty($order->info['comments'])) {
     $fields['s-t-1-36_order-note'] = $this->_sanitise($order->info['comments']);
   }

   $fields['i-f-1-11_interface-version'] = "3";
 //  $fields['s-t-1-30_payment-method-code'] = '';
   $tokendata =  sprintf("%s;%s;%s",
                          $fields['s-f-1-36_merchant-agreement-code'],
                          $fields['s-f-1-36_order-number'],
                          $order_timestamp
                        );

   $fields['s-f-32-32_payment-token'] = strtoupper(substr(hash('sha256',$tokendata),0,32));

   // fill in basket items
   $basket_item_count = 0;
   $basket_items_total = 0;
   foreach($order->products as $product) {
     $fields["s-t-1-30_bi-name-$basket_item_count"] = $this->_sanitise($product['name']);
     $fields["l-t-1-20_bi-unit-cost-$basket_item_count"] = $this->_convert_to_euro($product['final_price']*(1+($product['tax']/100)))*100;
     $fields["i-t-1-11_bi-unit-count-$basket_item_count"] = $product['qty'];
     $fields["l-t-1-20_bi-gross-amount-$basket_item_count"] = 
          $fields["l-t-1-20_bi-unit-cost-$basket_item_count"] *
          $fields["i-t-1-11_bi-unit-count-$basket_item_count"];
    $basket_items_total += $fields["l-t-1-20_bi-gross-amount-$basket_item_count"];
    $fields["l-t-1-20_bi-net-amount-$basket_item_count"] =  $fields["l-t-1-20_bi-gross-amount-$basket_item_count"];
    $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = $product['tax']*100;
    if(empty($fields["i-t-1-4_bi-vat-percentage-$basket_item_count"])) {
      $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = "0"; }
    $fields["i-t-1-4_bi-discount-percentage-$basket_item_count"] = "0";
    if(++$basket_item_count == 47) { break; }  // only 50 basket items supported, 2 reserved for shipping and other adjustments
   }
  // shipping
  if($_SESSION['shipping']['cost'] != 0) {
    $fields["s-t-1-30_bi-name-$basket_item_count"] = $this->_sanitise($_SESSION['shipping']['title']);
     $fields["l-t-1-20_bi-unit-cost-$basket_item_count"] = $this->_convert_to_euro($_SESSION['shipping']['cost']+$_SESSION['shipping_tax_amount'])*100;
    if(empty($fields["l-t-1-20_bi-unit-cost-$basket_item_count"])) {
      $fields["l-t-1-20_bi-unit-cost-$basket_item_count"]  = "0"; }
    $fields["i-t-1-11_bi-unit-count-$basket_item_count"] = '1';  
    $fields["l-t-1-20_bi-gross-amount-$basket_item_count"] = 
          $fields["l-t-1-20_bi-unit-cost-$basket_item_count"];
    $basket_items_total += $fields["l-t-1-20_bi-gross-amount-$basket_item_count"];
    $fields["l-t-1-20_bi-net-amount-$basket_item_count"] =  $fields["l-t-1-20_bi-gross-amount-$basket_item_count"];
   if($_SESSION['shipping']['cost'] != 0) {
      $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = ($shipping_tax_amount / $_SESSION['shipping']['cost'])*10000; } else {
       $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = '0'; }
      if(empty($fields["i-t-1-4_bi-vat-percentage-$basket_item_count"])) {
         $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = "0";  
      } else {
        $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = "0";
      }
    $fields["i-t-1-4_bi-discount-percentage-$basket_item_count"] = "0"; 
    $basket_item_count++;
  }
// possible others

  $difference = $fields['l-f-1-20_order-gross-amount'] - $basket_items_total;
  if(abs($difference) >= 1) {
   $fields["s-t-1-30_bi-name-$basket_item_count"] = $this->_sanitise(MODULE_PAYMENT_POINT_BASKET_ITEM_OTHERS);
   $fields["l-t-1-20_bi-unit-cost-$basket_item_count"] = $difference;
   $fields["i-t-1-11_bi-unit-count-$basket_item_count"] = '1';
   $fields["l-t-1-20_bi-gross-amount-$basket_item_count"] = 
          $fields["l-t-1-20_bi-unit-cost-$basket_item_count"];
   $fields["l-t-1-20_bi-net-amount-$basket_item_count"] =  $fields["l-t-1-20_bi-gross-amount-$basket_item_count"];
   $fields["i-t-1-4_bi-vat-percentage-$basket_item_count"] = '0';
   $fields["i-t-1-4_bi-discount-percentage-$basket_item_count"] = '0'; 
  }

  $fields["i-t-1-1_skip-confirmation-page"] = "1";  
   
  
  $fields["s-t-256-256_signature-one"] = 
    $this->_generatesignature($this->_formatparameters($fields));

    return $fields;

}
   
  // Return payment url to be used for connecting to the payment system
  // This function implements the Availability Get operation in the Point-e-commerce-payment interface
  // Required configuration: allow_url_fopen must be enabled
  function _get_payment_url() {
      if(!(ini_get('allow_url_fopen'))) {
      error_log('Point-ecommerce-payment: Fatal error: allow_url_fopen disabled. Please enable allow_url_fopen in PHP configuration');
      return false;
      }
     
     $payment_urls = array(MODULE_PAYMENT_POINT_ULR1);
     if(strlen(MODULE_PAYMENT_POINT_ULR2)>0) { $payment_urls[] = MODULE_PAYMENT_POINT_ULR2; }
     if(strlen(MODULE_PAYMENT_POINT_ULR3)>0) { $payment_urls[] = MODULE_PAYMENT_POINT_ULR3; }

    shuffle($payment_urls);
    
   if(MODULE_PAYMENT_POINT_AVAILABILITY_CHECK == 'False') { return $payment_urls[0]; }

    foreach($payment_urls as $url) {   
      // GET must result HTTP 200 OK and empty contents
      // anything else indicates that the payment system node is not available
      $fc = @file_get_contents($url);
      if($fc !== false and $fc == '' 
         and strpos($http_response_header[0],'200 200') !== false) {
         return $url;
        }
     }
    // flag error 
     return false;
   }
  
  // Converts sum to euros and rounds to 2 decimals
  function _convert_to_euro($sum) {
    $rate = $currencies->currencies['EUR']['value']; 
    if ($rate) {
      $price = zen_round($sum * $rate, 2);
      } else {
	$price = zen_round($sum, 2);
      }
    return $price;
  }

  // stores payment information to the point payments table
  // returns payment id
  function _store_db($sum) {
   
    $data_array = array('customer_id' => (int)$_SESSION['customer_id'], 'total_sum' => $sum);
    
    zen_db_perform('point_payments', $data_array);
    return mysql_insert_id();  // zen_db_insert_id only available at admin side
  }  

  // update payment info to the db
  // return sum of the payment db
  // returns false if the payment is not found or is processed already
  function _update_payment_db($payment_id, $transaction_id) {
    global $db;
    $sql = "UPDATE point_payments SET transaction_number = '" . 
           mysql_real_escape_string($transaction_id) . 
            "' , time_processed = NOW() WHERE payment_id = '" . (int) $payment_id .
            "' AND time_processed = '0000-00-00 00:00:00'";
    mysql_query($sql);

    if(mysql_affected_rows() == 0) { return false; }

    $sum_query = $db->Execute("SELECT total_sum FROM point_payments WHERE payment_id = '" . (int)$payment_id . "'");
     return $sum_query->fields['total_sum'];
  }    
    
    

 // Cryptutils functions
 function _formatparameters($parameters) {
   ksort($parameters, SORT_STRING);
   $formatedresult = "";
  foreach ($parameters as $key => $value)  {
    $value = str_replace(';',';;',$value);
    $formatedresult .= sprintf("%s=%s;", $key, $value);
  }
  return $formatedresult;
 }
  /** Creates signature for data
 * @param $data data to creta
 * @return string
 */
 function _generatesignature($data) {
   set_include_path(get_include_path() . PATH_SEPARATOR . dirname(__FILE__));
   $key = @file_get_contents($this->shop_private_key_file, true);

    if(!$key) { 
      error_log('Point payment: Could not read keyfile.');
      return false; }

    require('Crypt/RSA.php');
    $rsa = new Crypt_RSA();
    $rsa->setSignatureMode(CRYPT_RSA_SIGNATURE_PKCS1);
    $rsa->loadKey($key);

    $signature = $rsa->sign($data);

    return strtoupper(bin2hex($signature));
  }
/** Verifies the data signature
 * @param $datatoverify data to verify signature for
 * @param $signaturedata signature data as hex string
 * @return bool true - signature valid, false - invalid
 */
 function _verifysignature($datatoverify, $signaturedata) {
    set_include_path(get_include_path() . PATH_SEPARATOR . dirname(__FILE__));
    $key = @file_get_contents($this->pay_page_public_key_file, true);

    if(!$key) { 
      error_log('Point payment: Could not read keyfile.');
     return false; }

    require('Crypt/RSA.php');
    $rsa = new Crypt_RSA();
 
    $rsa->setSignatureMode(CRYPT_RSA_SIGNATURE_PKCS1);
    $rsa->loadKey($key);
    return $rsa->verify($datatoverify, pack("H*" , $signaturedata)) ? true : false;
  }

  // prepare data to be used for POST
  protected function _sanitise($data, $maxlen=30, $reverse=false) {
    $data = str_replace('"','',str_replace('\\','',$data));
    if(!$reverse) { return substr($data,0,$maxlen); } else {
    return substr($data, 0 - $maxlen);
   }
  }


  function _map_iso3_countrycode_to_numeric($iso3) {
    $codes = array("AFG"=>"004",         
"ALB"=>"008",         
"DZA"=>"012",         
"ASM"=>"016",         
"AND"=>"020",         
"AGO"=>"024",         
"AIA"=>"660",         
"ATA"=>"010",         
"ATG"=>"028",         
"ARG"=>"032",         
"ARM"=>"051",         
"ABW"=>"533",         
"AUS"=>"036",         
"AUT"=>"040",         
"AZE"=>"031",         
"BHS"=>"044",         
"BHR"=>"048",         
"BGD"=>"050",         
"BRB"=>"052",         
"BLR"=>"112",         
"BEL"=>"056",         
"BLZ"=>"084",         
"BEN"=>"204",         
"BMU"=>"060",         
"BTN"=>"064",         
"BOL"=>"068",         
"BIH"=>"070",         
"BWA"=>"072",         
"BVT"=>"074",         
"BRA"=>"076",         
"IOT"=>"086",         
"BRN"=>"096",         
"BGR"=>"100",         
"BFA"=>"854",         
"BDI"=>"108",         
"KHM"=>"116",         
"CMR"=>"120",         
"CAN"=>"124",         
"CPV"=>"132",         
"CYM"=>"136",         
"CAF"=>"140",         
"TCD"=>"148",         
"CHL"=>"152",         
"CHN"=>"156",         
"CXR"=>"162",         
"CCK"=>"166",         
"COL"=>"170",         
"COM"=>"174",         
"COG"=>"178",         
"COK"=>"184",         
"CRI"=>"188",         
"CIV"=>"384",         
"HRV"=>"191",         
"CUB"=>"192",         
"CYP"=>"196",         
"CZE"=>"203",         
"DNK"=>"208",         
"DJI"=>"262",         
"DMA"=>"212",         
"DOM"=>"214",         
"TMP"=>"626",         
"ECU"=>"218",         
"EGY"=>"818",         
"SLV"=>"222",         
"GNQ"=>"226",         
"ERI"=>"232",         
"EST"=>"233",         
"ETH"=>"231",         
"FLK"=>"238",         
"FRO"=>"234",         
"FJI"=>"242",         
"FIN"=>"246",     
"FRA"=>"250",         
"FXX"=>"249",         
"GUF"=>"254",         
"PYF"=>"258",         
"ATF"=>"260",         
"GAB"=>"266",         
"GMB"=>"270",         
"GEO"=>"268",         
"DEU"=>"276",         
"GHA"=>"288",         
"GIB"=>"292",         
"GRC"=>"300",         
"GRL"=>"304",         
"GRD"=>"308",         
"GLP"=>"312",         
"GUM"=>"316",         
"GTM"=>"320",         
"GIN"=>"324",         
"GNB"=>"624",         
"GUY"=>"328",         
"HTI"=>"332",         
"HMD"=>"334",         
"VAT"=>"336",         
"HND"=>"340",         
"HKG"=>"344",         
"HUN"=>"348",         
"ISL"=>"352",         
"IND"=>"356",         
"IDN"=>"360",         
"IRN"=>"364",         
"IRQ"=>"368",         
"IRL"=>"372",         
"ISR"=>"376",         
"ITA"=>"380",         
"JAM"=>"388",         
"JPN"=>"392",         
"JOR"=>"400",         
"KAZ"=>"398",         
"KEN"=>"404",         
"KIR"=>"296",         
"PRK"=>"408",         
"KOR"=>"410",         
"KWT"=>"414",         
"KGZ"=>"417",         
"LAO"=>"418",         
"LVA"=>"428",         
"LBN"=>"422",         
"LSO"=>"426",         
"LBR"=>"430",         
"LBY"=>"434",         
"LIE"=>"438",         
"LTU"=>"440",         
"LUX"=>"442",         
"MAC"=>"446",         
"MKD"=>"807",         
"MDG"=>"450",         
"MWI"=>"454",         
"MYS"=>"458",         
"MDV"=>"462",         
"MLI"=>"466",         
"MLT"=>"470",         
"MHL"=>"584",         
"MTQ"=>"474",         
"MRT"=>"478",         
"MUS"=>"480",         
"MYT"=>"175",         
"MEX"=>"484",         
"FSM"=>"583",         
"MDA"=>"498",         
"MCO"=>"492",         
"MNG"=>"496",         
"MSR"=>"500",         
"MAR"=>"504",         
"MOZ"=>"508",         
"MMR"=>"104",         
"NAM"=>"516",         
"NRU"=>"520",         
"NPL"=>"524",         
"NLD"=>"528",         
"ANT"=>"530",         
"NCL"=>"540",         
"NZL"=>"554",         
"NIC"=>"558",         
"NER"=>"562",         
"NGA"=>"566",         
"NIU"=>"570",         
"NFK"=>"574",         
"MNP"=>"580",         
"NOR"=>"578",         
"OMN"=>"512",         
"PAK"=>"586",         
"PLW"=>"585",         
"PAN"=>"591",         
"PNG"=>"598",         
"PRY"=>"600",         
"PER"=>"604",         
"PHL"=>"608",         
"PCN"=>"612",         
"POL"=>"616",         
"PRT"=>"620",         
"PRI"=>"630",         
"QAT"=>"634",         
"REU"=>"638",         
"ROM"=>"642",         
"RUS"=>"643",         
"RWA"=>"646",         
"KNA"=>"659",         
"LCA"=>"662",         
"VCT"=>"670",         
"WSM"=>"882",         
"SMR"=>"674",         
"STP"=>"678",         
"SAU"=>"682",         
"SEN"=>"686",         
"SYC"=>"690",         
"SLE"=>"694",         
"SGP"=>"702",         
"SVK"=>"703",         
"SVN"=>"705",         
"SLB"=>"090",         
"SOM"=>"706",         
"ZAF"=>"710",         
"SGS"=>"239",         
"ESP"=>"724",         
"LKA"=>"144",         
"SHN"=>"654",         
"SPM"=>"666",         
"SDN"=>"736",         
"SUR"=>"740",         
"SJM"=>"744",         
"SWZ"=>"748",         
"SWE"=>"752",         
"CHE"=>"756",         
"SYR"=>"760",         
"TWN"=>"158",         
"TJK"=>"762",         
"TZA"=>"834",         
"THA"=>"764",         
"TGO"=>"768",         
"TKL"=>"772",         
"TON"=>"776",         
"TTO"=>"780",         
"TUN"=>"788",         
"TUR"=>"792",         
"TKM"=>"795",         
"TCA"=>"796",         
"TUV"=>"798",         
"UGA"=>"800",         
"UKR"=>"804",         
"ARE"=>"784",         
"GBR"=>"826",         
"USA"=>"840",         
"UMI"=>"581",         
"URY"=>"858",         
"UZB"=>"860",         
"VUT"=>"548",         
"VEN"=>"862",         
"VNM"=>"704",         
"VGB"=>"092",         
"VIR"=>"850",         
"WLF"=>"876",         
"ESH"=>"732",         
"YEM"=>"887",         
"YUG"=>"891",         
"ZAR"=>"180",         
"ZMB"=>"894",         
"ZWE"=>"716");

    if(isset($codes[$iso3])) {
      return $codes[$iso3];
    } else {
    return "246";  // default to Finland
    }
  }

}

// EOF

